<?php
/*********************************************************
* DO NOT REMOVE *

Project: PHP Photo Gallery 1.0
Url: http://www.phpgalleryscript.org/

License------------------------------------------------:
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
End License----------------------------------------------

*********************************************************/

session_start();
if($_SESSION['admin']!='')
{
	@set_time_limit(300);
	require_once('../jadro/base.php');
	require_once('../jadro/core.func.inc.php');
	require_once('../jadro/libs/xajax/xajax.inc.php');
	require_once('../jadro/addfunc.php');
	require_once('../jadro/functions.php');
	require_once('../jadro/categories.inc.php');
	require_once('../jadro/mods/comment/comment.inc.php');
	require_once('../jadro/mods/ratings/ratings.inc.php');
	require_once('../jadro/libs/thumbnailer/thumbnail.inc.php');
	require_once('../jadro/libs/exif/exif.inc.php');
	require_once('../jadro/photo.inc.php');
	require_once('../jadro/libs/phpwatermark/watermark.php');

	if($_GET['p']=='')
	{
		@header('HTTP/1.1 301 Moved Permanently');
		@header('Location: ' . SITE_URL);
		exit();
	}

	definevars("where id='REWRITE_ENABLED' or id='EXIF' or id='ENABLE_RATINGS' or id='ENABLE_COMMENTS' or id='THUMBNAIL_WIDTH' or id='THUMBNAIL_HEIGHT' or id='THUMBNAIL_CONSTRAIN' or id='MIDWIDTH' or id='MIDHEIGHT' or id='MEDIUM_CONSTRAIN' or id='ADMIN_NAME' or id='WATERMARK'");

	global $xajax;
	$xajax = new xajax();
	$xajax->registerFunction('ajax_addrating');
	$xajax->registerFunction('ajax_resetratings');
	$xajax->registerFunction('ajax_deleteallcomments');
	$xajax->registerFunction('ajax_deletecomment');
	$xajax->registerFunction('ajax_addcomment');
	$xajax->registerFunction('ajax_approvecomment');
	$xajax->registerFunction('ajax_deletephoto');
	$xajax->registerFunction('ajax_savephoto');

	//ratings
	function ajax_addrating($rating,$id)
	{
		$rating=intval($rating);
		$id=intval($id);

		$resp=New xajaxResponse();

		if(ratings_add($rating,$id))
		{
			$nrating=ratings_getrating($id);
			$resp->addAssign('photorating','innerHTML',$nrating['itemrating']);
			$resp->addAssign('photoratingnumvotes','innerHTML',$nrating['numbervotes']);
			$resp->addAssign('newrating','innerHTML',' <small>average rating: ' . $nrating['itemrating'] . ' (' . $nrating['numbervotes'] . ' votes)</small>');
		}
		else
		$resp->addAlert('You have already rated or you have not selected rating!');

		return $resp;
	}

	function ajax_approvecomment($id)
	{
		$id=intval($id);
		comment_approve($id);
		$resp=New xajaxResponse();
		$resp->addAssign('comment_approve_' . $id,'innerHTML','');
		return $resp;
	}

	function ajax_resetratings($id)
	{
		$id=intval($id);
		ratings_reset($id);
		$resp=New xajaxResponse();
		$resp->addAssign('photorating','innerHTML','not rated.');
		$resp->addAssign('photoratingnumvotes','innerHTML','0');
		$resp->addAssign('ajaxinfo_ratings','innerHTML','<small>Ratings reset.</small>');
		return $resp;
	}

	function ajax_addcomment($comment)
	{
		$comment=array_map('htmlspecialchars_m',$comment);
		
		$nid=comment_save(array('approved'=>'yes','idpic'=>$comment['id'],'comment'=>$comment['comment_info'],'name'=>$comment['comment_name']));
		
		$comment['id']=$nid;

		$resp=New xajaxResponse();

		if($nid)
		{
			$resp->addRemove('nocomments');
			$resp->addScriptCall('js_addcomment',$comment);
		}
		else
		$resp->addAlert('Please complete the form!');
		$resp->addAssign('ajaxinfo_commentsubmit','innerHTML','');
		return $resp;
	}

	function ajax_deleteallcomments($id)
	{
		$id=intval($id);
		comment_deleteall($id);
		$resp=New xajaxResponse();
		$resp->addAssign('allcomments','innerHTML','');
		$resp->addAssign('ajaxinfo_comments','innerHTML','<small>All comments deleted</small>');
		return $resp;
	}
	function ajax_deletecomment($id)
	{
		$id=intval($id);
		comment_delete($id);
		$resp=New xajaxResponse();
		$resp->addAssign('comment_'.$id,'innerHTML','');
		$resp->addAssign('ajaxinfo_comments','innerHTML','<small>Comment deleted.</small>');
		return $resp;
	}

	function ajax_savephoto($ar)
	{
		global $db,$table;

		$resp=New xajaxResponse();

		$ar=array_map('htmlspecialchars_m',$ar);

		if($ar['caption']!='' && $ar['categoryid']!='')
		{
			$date_taken='';
			if($ar['photo_year']!='' && $ar['photo_month']!='')
			$date_taken=$ar['photo_month'] . ($ar['photo_day']!='' ? '.' . $ar['photo_day'] : '') .'.'. $ar['photo_year'] ;
			
			$oldphoto=getrow($table['items'],'photo,categoryid,approved',"where id='{$ar['id']}'");

			$sq="UPDATE {$table['items']} set photodesc='{$ar['photodesc']}',categoryid='{$ar['categoryid']}',caption='{$ar['caption']}',featured='{$ar['featured']}',date_taken='$date_taken' where id='{$ar['id']}'";

			$db->Execute($sq);

			if($oldphoto['approved']=='yes')
			{
				if($oldphoto['categoryid']!=$ar['categoryid'])
				{
					decnumphotos($oldphoto['categoryid']);
					incnumphotos($ar['categoryid']);
				}
			}
				
			$oldphoto=$oldphoto['photo'];

			$oldphoto=$ar['id'].'.'.getmimetype($oldphoto);
				
			if($_SESSION['uploadfile']!='')
			{
				deletephotofiles($oldphoto);

				unset($oldphoto);

				$mimetype=getmimetype($_SESSION['uploadfile']);

				$pic=$ar['id'] .'.'. $mimetype;

				$photopath=DATAPATH. '/upload/' . $_SESSION['uploadfile'];

				//exif
				if($ar['EXIF']==1)
				{
					$exifdata=exif_read($photopath);
					if($exifdata!==false)
					exif_savetodb($exifdata,$ar['id']);

					unset($exifdata);
				}

				//watermark
				if($ar['WATERMARK']==1)
				watermarkphoto_s($photopath);

				createphotothumbs($photopath,$pic);

				$hash=md5_file(DATAPATH.'/photos/'. $pic);
				$db->Execute("UPDATE {$table['items']} set photo='".$ar['id'] . '_' .$hash . '.' . $mimetype . "' where id='{$ar['id']}'");

			}
			else
			{
				$photopath=DATAPATH . '/photos/' . $oldphoto;
				//exif
				if($ar['EXIF']==1)
				{
					$exifdata=exif_read($photopath);
					if($exifdata!==false)
					exif_savetodb($exifdata,$ar['id']);

					unset($exifdata);
				}

				if($ar['WATERMARK']==1)
				{
					watermarkphoto_s($photopath);
					createphotothumbs($photopath,$oldphoto);
					$hash=md5_file($photopath);
					$db->Execute("UPDATE {$table['items']} set photo='".$ar['id'] . '_' .$hash . '.' . getmimetype($oldphoto) . "' where id='{$ar['id']}'");
				}
			}

			$_SESSION['uploadfile']='';

			$resp->addRedirect('editphoto.php?p=' . $ar['id']. '&saved');
		}
		else
		{
			$resp->addScriptCall('savephotoenable');
			$resp->addAssign('ajaxinfo_savephoto','innerHTML','<b>Photo title is missing or you have not selected album!</b>');
		}

		return $resp;

	}
	function ajax_deletephoto($id)
	{
		global $table;

		$id=intval($id);
		$resp=New xajaxResponse();

		$p=getrow($table['items'],'categoryid,photo,approved',"where id='$id'");

		if($p['approved']=='yes')
		decnumphotos($p['categoryid']);

		$photo=$id. '.' . getmimetype($p['photo']);

		deleteitems($table['items'],"where id='$id'");
		deletephotofiles($photo);
		
		$resp->addAlert('Photo deleted!');
		$resp->addRedirect('review.php?c=' . $p['categoryid']);
		return $resp;

	}
	$xajax->processRequests();

	$id=intval($_GET['p']);

	$smarty->assign('xajax',$xajax);
	$smarty->assign('xajax_dir',SITE_ROOT . '/jadro/libs/xajax/');
	$smarty->compile_dir = DATAPATH.'/admincache';
	$smarty->template_dir='./tpl/';
	$smarty->assign('usr',$_SESSION['admin']);


	$_SESSION['multipleupload']='1';
	$_SESSION['uploadfile']='';
	$_SESSION['instantstart']='';

	$photo=getrow($table['items'],'*',"where id='$id'");

	if($photo===false)
	{
		@header('HTTP/1.1 301 Moved Permanently');
		@header('Location: ' . SITE_URL);
		die();
	}

	if($photo['date_taken']!='')
	{
		$u=explode('.',$photo['date_taken']);
		$photo['month']=$u[0];
		$photo['day']=$u[1];
		$photo['year']=$u[2];
		
		if($u[2]=='')
		{
			$photo['day']='';
			$photo['year']=$u[1];
		}
				
		unset($u);
	}

	//ratings
	$rating=ratings_getrating($id);
	$smarty->assign('photorating',$rating['itemrating']);
	$smarty->assign('photoratingnumvotes',$rating['numbervotes']);
	unset($rating);

	//comments
	$comments=comment_getcomments_admin($id,80);
	$smarty->assign('comments',$comments['items']);
	$smarty->assign('numcomments',$comments['numitems']);
	unset($comments);

	//exif
	$smarty->assign('exifdata',exif_getfromdb($id));

	$ar=getchidandcatpath($photo['categoryid']);
	$smarty->assign('chid',$ar['chid']);
	$smarty->assign('uri',$ar['catpath']);

	$smarty->assign('title','Photo ' . $photo['caption']);
	$smarty->assign('photo',$photo);
	$smarty->assign('cat',$photo['categoryid']);
	$smarty->assign('FAVORITE',$photo['featured']);

	unset($photo,$row,$ar);

	$smarty->assign('enablecomment',ENABLE_COMMENTS);
	$smarty->assign('enableratings',ENABLE_RATINGS);
	$smarty->assign('EXIF',EXIF);
	$smarty->assign('WATERMARK',WATERMARK);
	$smarty->assign('conts_sel_cat',' id="c" class="ss" ');

	if(isset($_GET['saved']))
	$smarty->assign('saved',1);

	$smarty->register_function('nav_admin','nav_admin');
	$smarty->display('editphoto.tpl');
}
else
header('Location: index.php');
